/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

plugins {
    steamwar.kotlin
    id("io.ktor.plugin") version "2.3.12"
    id("org.jetbrains.kotlin.plugin.serialization") version "2.0.10"
    application
}

kotlin {
    jvmToolchain(21)
}

java {
    sourceCompatibility = JavaVersion.VERSION_21
    targetCompatibility = JavaVersion.VERSION_21
}

application {
    mainClass.set("de.steamwar.ApplicationKt")
}

tasks.build {
    finalizedBy(tasks.buildFatJar)
}

dependencies {
    implementation(libs.logback)
    implementation(libs.ktor)
    implementation(libs.ktorContentNegotiation)
    implementation(libs.ktorCors)
    implementation(libs.ktorSerialization)
    implementation(libs.ktorNetty)
    implementation(libs.ktorHost)
    implementation(libs.ktorRequestValidation)
    implementation(libs.ktorAuth)
    implementation(libs.ktorAuthJvm)
    implementation(libs.ktorAuthSession)
    implementation(libs.ktorClientCore)
    implementation(libs.ktorClientJava)
    implementation(libs.ktorClientContentNegotiation)
    implementation(libs.ktorClientAuth)
    implementation(libs.mysql)
    implementation(project(":CommonCore"))
    implementation(libs.yamlconfig)
    implementation(libs.kotlinxSerializationCbor)
    implementation(libs.ktorRateLimit)
    implementation(libs.nbt)

    implementation(libs.exposedCore)
    implementation(libs.exposedDao)
    implementation(libs.exposedJdbc)
    implementation(libs.exposedTime)
}
